﻿using AD_MAUI.Model;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace AD_MAUI.ViewModel
{
    public class AlbumViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler? PropertyChanged;

        private readonly Album album = new();

        public int Id { get => album.Id; }

        public string Title
        {
            get => album.Title;
        }

        public string Artist
        {
            get => album.Artist;
        }

        public string CoverImage
        {
            get => album.CoverImage;
        }

        public string Details
        {
            get => $"{album.Genre} · {album.Year}";
        }

        public ReadOnlyObservableCollection<SongViewModel> Songs { get => new(songs); }

        private readonly ObservableCollection<SongViewModel> songs;


        public AlbumViewModel(Album? album)
        {
            // Mocked data for testing
            this.album = album ?? new Album
            {
                Id = 1,
                Title = "Test Album",
                Artist = "Test Artist",
                CoverImage = "macroblank.png",
                Genre = "Test genre",
                Year = 1970,
                Songs = new List<Song>
                {
                    new Song { Id = 1, Title = "Test Song 1", Duration = 210 },
                    new Song { Id = 2, Title = "Test Song 2", Duration = 260 },
                    new Song { Id = 3, Title = "Test Song 3", Duration = 817 },
                }
            };
            songs = new ObservableCollection<SongViewModel>(this.album.Songs.Select(song => new SongViewModel(song)));
        }
    }
}